/* include/proto.h - Dclaration des diffrentes fonctions
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// Fonctions principales
int init_bot(int, int);
void sig_reload (int);
void sig_handler (int crap);
void sig_alarm(int);
void run_bot(int sock);

// Parses
void parse_this(int, char *);
void m_ping(int, int, char **);
void m_privmsg(int, int, char **);
void m_pass(int, int, char **);
void m_kick(int, int, char **);
void m_part(int, int, char **);
void m_join(int, int, char **);
void m_account(int, int, char **);
void m_mode(int, int, char **);
void m_eob(int, int, char **);
void m_squit(int, int, char **);
void m_server(int, int, char **);
void m_create(int, int, char **);
void m_nick(int, int, char **);
void m_quit(int, int, char **);
void m_burst(int, int, char **);
void m_away(int, int, char **);
void m_sethost(int, int, char **);
void m_setident(int, int, char **);
void m_whois(int, int, char **);
void m_kill(int, int, char **);
void m_topic(int, int, char **);

// Outils serveur
void putserv(const char *, ...);
void putchan(const char *);
//void log(char *, char *, ...);
void putlog(char *, const char *, ...);
void csntc(aNick *, const char *, ...);
void syntax_cmd(aNick *, int);

void csmode(aChan *, const char *, ...);
void cstopic(aChan *chan, const char *, ...);
void cskick(const char *, const char *, const char *, ...);
void cspart(const char *, const char *, ...);
void cswallops(const char *, ...);
void cswall(const char *, ...);
void csjoin(aChan *);
void cs_account(aNick *nick, const char *);

char *nick2num(const char *);
char *make_servnum(int);
char *num2nick(const char *);
void get_time(long ttime, char *);
//char *parv2msg(unsigned int parc, char **parv, unsigned int base);
void parv2msgn(unsigned int parc, char **parv, unsigned int base, char *buf, unsigned int size);
char *mkpass(char *, char *);
void duration(int, char *);
void conv_char(char *chan, char *string);
struct nickinfo *num2nickinfo(const char *);
struct Link *num2servinfo(char *);

int decode_num (const char *);
int resolve(char *host);
int is_ip(char *);
void translate_esc(char *, char *, char *);
long convert_duration(char *, long);
void strupr(char *);
char *bottime();
void strip_newline(char *);
void strlwr(char *buf);
int is_num(char *num);
int match(const char *, const char *);
int ToggleFlag(int, int);

void do_killcheck();
void check_kills();
void check_bans();
void check_ignores();
void check_accounts();
void check_chans();

#ifdef HAVE_CRYPTHOST
char *hostprot(unsigned char *, unsigned char *);
#endif
char *strip_lastword(char *rest);
int isignore(aNick *nick);
#ifdef HAVE_TRACK
struct track *istrack(anUser *user);
void del_track(anUser *nick);
#endif
void show_vote(aNick *nick);

// Fichiers
int load_config(char *);
void load_users();
void write_anuser(anUser *);
void write_userlist();
void write_users();
void write_badchans();
void load_badchans();
void write_achan(aChan *);
void write_chans();
void write_chanlist();
void load_chans();
void load_welcome();
void write_welcome();
void write_badnicks();
void load_badnicks();
void write_cmds();
void load_cmds();
void write_bans(aChan *);
void load_votes();
void write_votes();
void append_file(char *, char *);

// Get Infos
int IsBadNick(const char *);
int IsRegChan(const char *);
int IsRegNick(char *);
char *IsAnOwner(const char *);
char *IsOwner(char *, char *);

char *getbanmask(char *nick, char *ident, char *host, int bantype);
void show_accessn(struct access *access, struct userinfo *user, aNick *num);
int getgloballevel(aNick *nick);
int ChanLevelbyUserI(anUser *user, char *chan);
int check_protect(aNick *, aNick *, char *);
int checkflood(aNick *nick);
int chan_check(char *, aNick *);
int getoption(char *, char **, int, int, int);
int IsValidNick(char *);
int IsValidMail(char *);
int GetCmdIndexbyName(char *);

struct userinfo *getuserinfo(const char *);
struct badchans *getbadchan(const char *);
struct chaninfo *getchaninfo(const char *);
struct badnicks *getbadnick(const char *);
struct joininfo *getjoininfo(aNick *, const char *);
struct nickinfo *getnickbynick(const char *);
struct access *GetAccessIbyUserI(anUser *, const char *chan);
struct Link *GetLinkIbyServ(const char *serv);

// Add/Del infos
#ifdef USE_MEMOSERV
void add_memo(anUser *user, char *,int, char *);
void del_memo(anUser *user, unsigned int);
#endif
struct userinfo *add_regnick(char *, char *, int, int, int, int, char *, int);
void del_regnick(anUser *user);
void del_nickinfo(aNick *nick);
#ifdef HAVE_CRYPTHOST
struct nickinfo *add_nickinfo(char *, char *, char *, char *, char *, char *, char *, char *, long, char *);
#else
struct nickinfo *add_nickinfo(char *, char *, char *, char *, char *, char *, char *, long, char *);
#endif
struct badchans *add_abadchan(char *, char *);
void del_abadchan(const char *);
struct chaninfo *add_chan(char *, char *, char *, char *, char *, char *, char *, int, char *, int, int, int ,int, int, int, char *, char *);
void add_access(struct userinfo *user, char *, int, int, char *, long);
void del_chan(char *);
void del_access(anUser *, aChan *);
void add_killinfo(char *, char *, long, int, int);
void del_killinfo(const char *, const char *);
void add_abadnick(char *);
void del_abadnick(const char *);
void add_join(aNick *nick, char *, int, int, long, int);
void del_join(aNick *nick, char *);
void del_link(aChan *chan, const char *);
void add_ban(aChan *chan, char *, char *, char *, long, long, int);
void del_ban(aChan *chan, const char *);
void add_ignore(char *, long);
void del_ignore(const char *);
void add_waitaccess(struct userinfo *user, char *, int);
void del_waitaccess(const char *, const char *);
void parse_umode(aNick *nick, char *);
void parse_cmode(aChan *, char *, char *, char *);

// Commandes :
void register_user(aNick *nick, aChan *chaninfo, int parc, char **parv);
void hello_world(aNick *nick, aChan *chaninfo, int parc, char **parv);
void drop_user(aNick *nick, aChan *chaninfo, int parc, char **parv);
void showcommands(aNick *nick, aChan *chaninfo, int parc, char **parv);
void uptime(aNick *nick, aChan *chaninfo, int parc, char **parv);
void ns_login(aNick *nick, aChan *chaninfo, int parc, char **parv);
void ctcp_ping(aNick *nick, aChan *chaninfo, int parc, char **parv);
void ctcp_version(aNick *nick, aChan *chaninfo, int parc, char **parv);
void copyright(aNick *nick, aChan *chaninfo, int parc, char **parv);
void die(aNick *nick, aChan *chaninfo, int parc, char **parv);
#ifdef USE_MEMOSERV
void send_memo(aNick *nick, aChan *chaninfo, int parc, char **parv);
void memos(aNick *nick, aChan *chaninfo, int parc, char **parv);
#endif
void inviteme(aNick *nick, aChan *chaninfo, int parc, char **parv);
void show_admins(aNick *nick, aChan *chaninfo, int parc, char **parv);
void aide(aNick *nick, aChan *chaninfo, int parc, char **parv);
void register_chan(aNick *nick, aChan *chaninfo, int parc, char **parv);
void unreg_chan(aNick *nick, aChan *chaninfo, int parc, char **parv);
void list_badchans(aNick *nick, aChan *chaninfo, int parc, char **parv);
void show_access(aNick *nick, aChan *chaninfo, int parc, char **parv);
void do_admin(aNick *nick, aChan *chaninfo, int parc, char **parv);
void del_admin(aNick *nick, aChan *chaninfo, int parc, char **parv);
void admin_level(aNick *nick, aChan *chaninfo, int parc, char **parv);
void set_welcome(aNick *nick, aChan *chaninfo, int parc, char **parv);
void welcome_privmsg(aNick *nick, aChan *chaninfo, int parc, char **parv);
void list_badnicks(aNick *nick, aChan *chaninfo, int parc, char **parv);
void cs_whois(aNick *nick, aChan *chaninfo, int parc, char **parv);
void add_user(aNick *nick, aChan *chaninfo, int parc, char **parv);
void del_user(aNick *nick, aChan *chaninfo, int parc, char **parv);
void op(aNick *nick, aChan *chaninfo, int parc, char **parv);
void deop(aNick *nick, aChan *chaninfo, int parc, char **parv);
void admin_user(aNick *nick, aChan *chaninfo, int parc, char **parv);
void kick(aNick *nick, aChan *chaninfo, int parc, char **parv);
void kickban(aNick *nick, aChan *chaninfo, int parc, char **parv);
void verify(aNick *nick, aChan *chaninfo, int parc, char **parv);
void chaninfo(aNick *nick, aChan *chaninfo, int parc, char **parv);
void admin_chan(aNick *nick, aChan *chaninfo, int parc, char **parv);
void opall(aNick *nick, aChan *chaninfo, int parc, char **parv);
void deopall(aNick *nick, aChan *chaninfo, int parc, char **parv);
void mode(aNick *nick, aChan *chaninfo, int parc, char **parv);
void topic(aNick *nick, aChan *chaninfo, int parc, char **parv);
void rdeftopic(aNick *nick, aChan *chaninfo, int parc, char **parv);
void rdefmodes(aNick *nick, aChan *chaninfo, int parc, char **parv);
void ban_cmd(aNick *nick, aChan *chaninfo, int parc, char **parv);
void info(aNick *nick, aChan *chaninfo, int parc, char **parv);
void invite(aNick *nick, aChan *chaninfo, int parc, char **parv);
void banlist(aNick *nick, aChan *chaninfo, int parc, char **parv);
void clearmodes(aNick *nick, aChan *chaninfo, int parc, char **parv);
void voice(aNick *nick, aChan *chaninfo, int parc, char **parv);
void devoice(aNick *nick, aChan *chaninfo, int parc, char **parv);
void clear_bans(aNick *nick, aChan *chaninfo, int parc, char **parv);
void unban(aNick *nick, aChan *chaninfo, int parc, char **parv);
void unbanme(aNick *nick, aChan *chaninfo, int parc, char **parv);
void admin_do(aNick *nick, aChan *chaninfo, int parc, char **parv);
void admin_say(aNick *nick, aChan *chaninfo, int parc, char **parv);
void lastseen(aNick *nick, aChan *chaninfo, int parc, char **parv);
void locktopic(aNick *nick, aChan *chaninfo, int parc, char **parv);
void strictop(aNick *nick, aChan *chaninfo, int parc, char **parv);
void nobans(aNick *nick, aChan *chaninfo, int parc, char **parv);
void noops(aNick *nick, aChan *chaninfo, int parc, char **parv);
void deftopic(aNick *nick, aChan *chaninfo, int parc, char **parv);
void defmodes(aNick *nick, aChan *chaninfo, int parc, char **parv);
void description(aNick *nick, aChan *chaninfo, int parc, char **parv);
void csetwelcome(aNick *nick, aChan *chaninfo, int parc, char **parv);
void myaccess(aNick *nick, aChan *chaninfo, int parc, char **parv);
void banlevel(aNick *nick, aChan *chaninfo, int parc, char **parv);
void voiceall(aNick *nick, aChan *chaninfo, int parc, char **parv);
void devoiceall(aNick *nick, aChan *chaninfo, int parc, char **parv);
void kickbanall(aNick *nick, aChan *chaninfo, int parc, char **parv);
void kickall(aNick *nick, aChan *chaninfo, int parc, char **parv);
void activwelcome(aNick *nick, aChan *chaninfo, int parc, char **parv);
void see_alist(aNick *nick, aChan *chaninfo, int parc, char **parv);
void recover(aNick *nick, aChan *chaninfo, int parc, char **parv);
void rctopics(aNick *nick, aChan *chaninfo, int parc, char **parv);
void rdtopics(aNick *nick, aChan *chaninfo, int parc, char **parv);
void rehash_conf(aNick *nick, aChan *chaninfo, int parc, char **parv);
void deauth(aNick *nick, aChan *chaninfo, int parc, char **parv);
void restart_bot(aNick *nick, aChan *chaninfo, int parc, char **parv);
void cs_wall(aNick *nick, aChan *chaninfo, int parc, char **parv);
void show_ignores(aNick *nick, aChan *chaninfo, int parc, char **parv);
void reop(aNick *nick, aChan *chaninfo, int parc, char **parv);
void bantype(aNick *nick, aChan *chaninfo, int parc, char **parv);
void nickban(aNick *nick, aChan *chaninfo, int parc, char **parv);
void chcomname(aNick *nick, aChan *chaninfo, int parc, char **parv);
void chlevel(aNick *nick, aChan *chaninfo, int parc, char **parv);
void oubli_pass(aNick *nick, aChan *chaninfo, int parc, char **parv);
void disable_cmd(aNick *nick, aChan *chaninfo, int parc, char **parv);
void ren_chan(aNick *nick, aChan *chaninfo, int parc, char **parv);
void cmd_track(aNick *nick, aChan *chaninfo, int parc, char **parv);
void chanurl(aNick *nick, aChan *chaninfo, int parc, char **parv);
void write_files(aNick *nick, aChan *chaninfo, int parc, char **parv);
void accept_an_access(aNick *nick, aChan *chaninfo, int parc, char **parv);
void globals_cmds(aNick *nick, aChan *chan, int parc, char **parv);
void whoison(aNick *nick, aChan *chaninfo, int parc, char **parv);
void set_protect(aNick *nick, aChan *chaninfo, int parc, char **parv);
void do_vote(aNick *nick, aChan *chaninfo, int parc, char **parv);
void voter(aNick *nick, aChan *chaninfo, int parc, char **parv);
void vote_results(aNick *nick, aChan *c, int parc, char **parv);
void showconfig(aNick *nick, aChan *c, int parc, char **parv);
void set_motds(aNick *nick, aChan *c, int parc, char **parv);
void badmanage(aNick *nick, aChan *c, int parc, char **parv);
void user_set(aNick *nick, aChan *c, int parc, char **parv);

//Welcome
void add_welcome(aNick *nick, aChan *c, int parc, char **parv);
void del_welcome(aNick *nick, aChan *c, int parc, char **parv);
void list_welcome(aNick *nick, aChan *c, int parc, char **parv);
void choose_welcome(char *num);
void send_welcome(char *num, struct welcomeinfo *w);
void add_loadwelcome(int level, char *msg);

//Moduser
void generic_moduser(aNick *nick, aChan *chaninfo, int parc, char **parv);
void moduser_protect(aNick *nick, aChan *chaninfo, int parc, char **parv);
void moduser_autovoice(aNick *nick, aChan *chaninfo, int parc, char **parv);
void moduser_autoop(aNick *nick, aChan *chaninfo, int parc, char **parv);

//Chanopt
void generic_chanopt(aNick *nick, aChan *chaninfo, int parc, char **parv);
void define_motd(aNick *nick, aChan *chaninfo, int parc, char **parv);
