/* src/admin_cmds.c - Diverses commandes pour admins
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <time.h>
#include <main.h>

CVSINFO("$Id: admin_cmds.c,v 1.2 2003/02/15 16:13:09 romexzf Exp $");

extern const int lastresetparse;
extern const int lastresetlogs;
extern const int kill_interval;
extern int want_to_quit;
extern char *quit_msg;
extern char user_motd[];
extern char admin_motd[];

extern struct badchans *badchead;
extern struct badnicks *badnhead;

extern struct cs_commands cs_cmds[];

void inviteme(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
    putserv("%s %s %s :%s\n", cs.num, TOKEN_INVITE, nick->nick, cs.chan);
    return;
}

void clearallmem()
{
	aNick *n, *nt;
	aJoin *j, *jt;
	aChan *c, *ct;
	aBan *b, *bt;
	anUser *u, *ut;
	anAccess *a, *at;
	struct memos *m, *mt;
	struct waitaccess *w, *wt;
	struct badchans *bc, *bct;
	struct badnicks *bn, *bnt;
	struct ignore *ii, *it;
	struct killinfo *k, *kt;
	extern char *mailprog;
	extern struct killinfo *killhead;
	extern struct ignore *ignorehead;
	extern struct Link *mainhub;
	struct Link *l, *lt;

	free(quit_msg);
	free(mailprog);

	for(bc=badchead;bc;bc=bct)
	{
		bct=bc->next;
		free(bc);
	}
	for(bn=badnhead;bn;bn=bnt)
	{
		bnt=bn->next;
		free(bn);
	}
	for(c=chanhead;c;c=ct)
	{
		ct=c->next;
		for(b=c->banhead;b;b=bt)
		{
			bt=b->next;
			free(b);
		}
		free(c);
	}
	for(u=userhead;u;u=ut)
	{
		ut=u->next;
		for(a=u->accesshead;a;a=at)
		{
			at=a->next;
			free(a);
		}
		for(m=u->memohead;m;m=mt)
		{
			mt=m->next;
			free(m);
		}
		for(w=u->wahead;w;w=wt)
		{
			wt=w->next;
			free(w);
		}
		free(u);
	}
	for (n=nickhead;n;n=nt)
	{
		nt=n->next;
		for(j=n->joinhead;j;j=jt)
		{
			jt=j->next;
			free(j);
		}
		free(n);
	}
	for(k=killhead;k;k=kt)
	{
		kt=k->next;
		free(k);
	}
	for(ii=ignorehead;ii;ii=it)
	{
		it=ii->next;
		free(ii);
	}
	for(l=mainhub;l;l=lt)
	{
		lt=l->next;
		free(l);
	}
	return;
}

void die(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char r[450];

	want_to_quit = 1;
	if(!parc) strcpy(r, quit_msg);
	else parv2msgn(parc, parv, 1, r, 450);
	write_cmds();

#ifdef USE_CHANSERV
	putserv("%s %s :%s (par \2%s\2)\n", cs.num, TOKEN_QUIT, r, nick->nick);
#endif
#ifdef USE_WELCOMESERV
	putserv("%s %s :%s (par \2%s\2)\n", ws.num, TOKEN_QUIT, r, nick->nick);
#endif

	putserv("%s %s %s 0 :%s (par \2%s\2)\n", bot.servnum, TOKEN_SQUIT, bot.server, r, nick->user->nick);

	clearallmem();
	return;
}

/*
 * restart_bot
 *
 * parv[1->parc-1] = reason
 */
void restart_bot(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	FILE *fuptime;
	char r[450];

	if((fuptime = fopen("uptime.tmp", "w"))) // permet de maintenir l'uptime (/me tricheur)
	{
		fprintf(fuptime, "%d %d %d", tuptime, lastresetparse, lastresetlogs);
		fclose(fuptime);
		/* Comme je m'emmerde, voici un c/c de ce qu'il se passe grce  a :
		 -*-> (183552) @Progs > !uptime
		 -*-> (183552) -Z- Je suis connect depuis 20 heures 31 minutes et 14 secondes
		 -*-> (183555) @Progs > !restart
		 -*-> (183556) <== (QUIT) Z (SCoderZ@Service.Inter-System.Net) Raison: Maintenance [RESTART] (par Progs)
		 -*-> (183623) -Z- Vous avez t ridentifi
		 -*-> (183623) -Z/Wallops- Synchronisation de 581 bytes en     0.002405 s (Taux   235.918017 Ko/s)
		 -*-> (183623) ==> (JOIN) Z (SCoderZ@Service.Inter-System.Net) sur #Services
		 -*-> (183623) === (MODE) #Services +o Z par Services.Inter-System.Net
		 -*-> (183626) @Progs > !uptime
		 -*-> (183626) -Z- Je suis connect depuis 20 heures 31 minutes et 48 secondes
		 * comme (18:36:26) - (28:35:52) = (20:31:48) - (20:31:14) a marche :)
		 * dsl pour le flood
		 */
	}

	want_to_quit = 1;
	if(!parc) strcpy(r, quit_msg);
	else parv2msgn(parc, parv, 1, r, 450);
	write_cmds();

#ifdef USE_CHANSERV
	putserv("%s %s :%s [\2RESTART\2] (par \2%s\2)\n", cs.num, TOKEN_QUIT, r, nick->nick);
#endif
#ifdef USE_WELCOMESERV
	putserv("%s %s :%s [\2RESTART\2] (par \2%s\2)\n", ws.num, TOKEN_QUIT, r, nick->nick);
#endif

	putserv("%s %s %s 0 :%s [\2RESTART\2] (par \2%s\2)\n", bot.servnum, TOKEN_SQUIT, bot.server, r, nick->user->nick);

	clearallmem();

	system("./services");
	return;
}

void cs_wall(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aNick *n;
	char buf[400];

	parv2msgn(parc,parv,1,buf,400);

	for(n=nickhead;n;n=n->next)
	  if(n->user && IsAnAdmin(n->user)) csntc(n, "CSWall de \002%s\002: %s", nick->nick, buf);
	return;
}

void chcomname(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char newcmd[15], *lastcmd = NULL;
	int i, icmd = 0;

	if(strlen(parv[2]) > 14)
	{
		csntc(nick, "Un nom de commande ne doit pas dpasser 14 caractres");
		return;
	}
	strcpy(newcmd, parv[2]);
	lastcmd = parv[1];
	for(i=0;cs_cmds[i].cmd[0] != '\0';i++)
		if(!strcasecmp(lastcmd, cs_cmds[i].cmd))
		{
			if(cs_cmds[i].cmd[0] == '\001')
			{
				csntc(nick, "Vous ne pouvez pas changer le nom des commandes en ctcp");
				return;
			}
			icmd = i;
		}
		else if(!strcasecmp(newcmd, cs_cmds[i].cmd))
		{
			csntc(nick, "La commande %s existe dj", newcmd);
			return;
		}
	if(icmd)
	{
		strcpy(cs_cmds[icmd].cmd, newcmd);
		csntc(nick, "La commande \002%s\002 est appele maintenant \002%s\002", lastcmd, cs_cmds[icmd].cmd);
		write_cmds();
	}
	else
		csntc(nick, "La commande \002%s\002 existe pas !", lastcmd);
	return;
}

void chlevel(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	const char *cmd = parv[1];
	int level = 0, i,old;

	if(!is_num(parv[2]) || atoi(parv[2]) > 500 || atoi(parv[2]) < 0)
	{
		csntc(nick, "Un niveau doit tre un nombre entre 0 et 500");
		return;
	}

	level = atoi(parv[2]);
	if(nick->user && level > nick->user->level && level < 5)
	{
		csntc(nick, "\002Vous ne pouvez pas donner un niveau  %s plus grand que le votre !\002", cmd);
		return;
	}

	for(i=0;cs_cmds[i].cmd[0] != '\0';i++)
	{
		if(!strcasecmp(cmd, cs_cmds[i].cmd))
		{
			if(!cs_cmds[i].chan && level > 4)
			{
				csntc(nick, "Le niveau d'une commande d'user ne doit pas dpasser le niveau 4");
				return;
			}

			old=cs_cmds[i].level;
			if(old == level)
			{
				csntc(nick, "Veuillez un level diffrent de l'actuel.");
				return;
			}

			cs_cmds[i].level = level;
			csntc(nick, "Le niveau de la commande %s est maintenant \002%d\002.", cs_cmds[i].cmd,cs_cmds[i].level);

			if(cs_cmds[i].level < 2)
				csntc(nick, "Cette commande s'adresse aux users simple (%s)", cs_cmds[i].level ? "reg" : "tout le monde");
			else if(cs_cmds[i].level < 5 && old < 2)
				csntc(nick, "C'est maintenant une commande pour les admins.");
			write_cmds();
			return;
		}
	}
	csntc(nick, "La commande \002%s\002 existe pas !", cmd);
	return;
}

void disable_cmd(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	const char *cmd = parv[1];
	int disable = 0, i;

	if(!strcasecmp(parv[2], "ON")) disable = 1;
	else if(!strcasecmp(parv[2], "OFF")) disable = 0;
	else
	{
		csntc(nick, "Vous devez prciser la commande est desactive grace  ON ou OFF");
		return;
	}
	for(i=0;cs_cmds[i].cmd[0] != '\0';i++)
		if(!strcasecmp(cmd, cs_cmds[i].cmd))
		{
			if(!strcasecmp(cs_cmds[i].realcmd, "DISABLE")
			|| !strcasecmp(cs_cmds[i].realcmd, "CHCOMNAME")
			|| !strcasecmp(cs_cmds[i].realcmd, "CHLEVEL"))
			{
				csntc(nick, "Veuillez ne pas desactiver \2%s\2 !", cmd);
				return;
			}
			cs_cmds[i].disable = disable;
			csntc(nick, "La commande %s est maintenant \002%sactive\002", cs_cmds[i].cmd, disable ? "des" : "");
			write_cmds();
			return;
		}
	csntc(nick, "La commande \002%s\002 existe pas !", cmd);
	return;
}

void set_motds(aNick *nick, aChan *c, int parc, char **parv)
{
	if(!strcasecmp("none", parv[2]))
	{
		parv[2]="";
		parc = 2;
	}

	if(!strcasecmp(parv[1], "USER")) parv2msgn(parc, parv, 2, user_motd, 390);
	else if(!strcasecmp(parv[1], "ADMIN")) parv2msgn(parc, parv, 2, admin_motd, 390);
	else
	{
		csntc(nick, "Il n'y a pas de motd pour %s", parv[1]);
		return;
	}
	if(parv[2]!="") csntc(nick, "Le motd pour les %ss est maintenant:\2 %s", parv[1], !strcasecmp(parv[1], "USER")?user_motd:admin_motd);
	else csntc(nick, "Le motd pour les %ss a bien t supprim", parv[1]);
	write_welcome();
	return;
}

/* cmds (c) keeo (le 3 en 1 par progs)*/
void globals_cmds(aNick *nick, aChan *chan, int parc, char **parv)
{
	const char *cmd = parv[1];
	char *msg, msg2[400];

	if(strcasecmp(cmd, "MEMO")) parv2msgn(parc, parv, 2, msg2, 400);
	msg=(strcasecmp(cmd, "MEMO"))?msg2:NULL;
	if(msg && *msg == ':') msg++;
	if(!strcasecmp(cmd, "WALL"))
	{
		aNick *n;
		for(n=nickhead;n;n=n->next)
		  csntc(n, "[\002Notice Globale\002] %s - \002%s\002", msg, nick->nick);
		return;
	}
	if(!strcasecmp(cmd, "MSG"))
	{
		for(chan = chanhead;chan;chan=chan->next)
		  putserv("%s %s %s :\2%s >\2 %s\n", cs.num, TOKEN_PRIVMSG, chan->chan, nick->nick, msg);
		return;
	}
	if(!strcasecmp(cmd, "CNOTICE"))
	{
		for(chan = chanhead;chan;chan=chan->next)
		  putserv("%s %s %s :%s - \002%s\002\n", cs.num, TOKEN_NOTICE, chan->chan, msg, nick->nick);
		return;
	}
#ifdef USE_MEMOSERV
	if(!strcasecmp(cmd, "MEMO"))
	{
		char memo[MEMOLEN];
		anUser *user;
		aNick *who;
		unsigned int min_level = 0, max_level = 0, mask = 0, i;

		for(i=2;i;i++)
		{
			if(parv[i][0]=='-')	i++;
			else
			{
				parv2msgn(parc, parv, i, msg2, 400);
				break;
			}
		}
		strncpy(memo,msg,MEMOLEN);

		min_level = getoption("-min",parv,parc,2,1);
		max_level = getoption("-max",parv,parc,2,1);
		if(max_level > 4 || min_level > 4)
		{
			csntc(nick, "Les niveaus maximum ou minimum  spcifier doivent tre compris entre 1 et 4 (c'est les niveau d'users)");
			return;
		}
		mask = getoption("-user",parv,parc,2,0);
		user = userhead;
		while(user)
		{
			if(user->nick != nick->user->nick && (!min_level || user->level >= min_level)
			   && (!max_level || user->level <= max_level) && (!mask || !match(parv[mask], user->nick)))
			{
				who = user->n;
				if(who && !who->away)
					csntc(who, "\002MEMO DE %s :\002 %s", nick->nick, msg);
				add_memo(user, nick->user->nick, time(NULL), memo);
			}
			user = user->next;
		}
		csntc(nick, "Un memo a bien t envoy  tout le monde respectant les critres donns (si spcifis) avec le texte suivant :");
		csntc(nick, "  \002%s\002", msg);
		write_users();
		return;
	}
#endif
	csntc(nick, "La sous commande %s n'existe pas",cmd);
	syntax_cmd(nick, GetCmdIndexbyName("GLOBAL"));
	return;
}


/*
 * del_badchan
 *
 * parv[1] = chaine
 */
void del_badchan(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char *chaine = parv[1];
	struct badchans *badchan;

	if(!(badchan = getbadchan(chaine)))
	{
		csntc(nick, "La chaine %s n'existe pas", chaine);
		return;
	}
	del_abadchan(badchan->chaine);
	csntc(nick, "La chaine \002%s\002 a bien t supprime", chaine);
	write_badchans();
	return;
}

/*
 * add_badchan
 *
 * parv[1] = chaine
 */
void add_badnick(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char chaine[NICKLEN];
	struct badchans *badchan = NULL;

	if(IsBadNick(parv[1]))
	{
		csntc(nick, "Une chaine a dj t enregistre contenant celle ci: \002%s\002 (\002%s\002)\002.", badchan->chaine, badchan->raison);
		csntc(nick, "Si la chaine \002%s\002 est vrifie, il est normal que la votre aussi", badchan->chaine);
		return;
	}
	strncpy(chaine, parv[1], NICKLEN);
	csntc(nick, "\002%s\002 est maintenant un pseudo illgal", chaine);
	add_abadnick(chaine);
	csntc(nick, "Tous les users qui voudront prendre ce pseudo se feront dconnecter au bout de %d secondes.", kill_interval);
	append_file(BADNICKS_FILE, chaine);
	return;
}

/*
 * del_badnick
 *
 * parv[1] = chaine
 */
void del_badnick(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char chaine[NICKLEN];
	struct badnicks *badnick;

	strncpy(chaine, parv[1], NICKLEN);

	if(!(badnick = getbadnick(chaine)))
	{
		csntc(nick, "La chaine %s n'existe pas", chaine);
		return;
	}
	del_abadnick(badnick->chaine);
	csntc(nick, "La chaine \002%s\002 a bien t supprime", chaine);
	write_badnicks();
	return;
}

void badmanage(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	const char *type=parv[1], *cmd=parv[2];

	if(strcasecmp(type,"nick") && strcasecmp(type, "chan"))
	{
		csntc(nick ,"Invalide type: veuillez choisir 'nick' ou 'chan'");
		syntax_cmd(nick, GetCmdIndexbyName("abad"));
		return;
	}
	if(strcasecmp(cmd,"del") && strcasecmp(cmd,"add") && strcasecmp(cmd, "list"))
	{
		csntc(nick ,"Invalide commande: veuillez choisir 'del', 'add' ou 'list'");
		syntax_cmd(nick, GetCmdIndexbyName("abad"));
		return;
	}
	if(!strcasecmp(type,"chan"))
	{
		if(!strcasecmp(cmd,"add"))
		{
			char chaine[100], raison[150], tmp[255];
			struct badchans *badchan;

			if(parc<4)
			{
				csntc(nick, "Syntaxe: ABAD CHAN ADD <mask/chan> <raison>");
				return;
			}

			if((badchan = getbadchan(parv[3])))
			{
				csntc(nick, "%s est dj couvert par \002%s\002 (\002%s\002)\002.", parv[3], badchan->chaine, badchan->raison);
				return;
			}
			strncpy(chaine, parv[3], 100);
			parv2msgn(parc, parv, 4, raison, 150);/*pas de boucles inutiles avt les check*/
			badchan=add_abadchan(chaine, raison);
			csntc(nick, "La chaine \002%s\002 a bien t ajoute avec la raison: \002%s", chaine, raison);
			csntc(nick, "Aucun salon contenant cette chaine ne pourra tre enregistr par les Users.");
			snprintf(tmp, 255, "%s :%s", badchan->chaine, badchan->raison);
			append_file(BADCHANS_FILE, tmp);
		}
		else if(!strcasecmp(cmd,"del"))
		{
			if(parc<3)
			{
				csntc(nick, "Syntaxe: ABAD CHAN DEL <mask/chan> <raison>");
				return;
			}
			parv[1]=parv[3];
			del_badchan(nick,chaninfo,parc,parv);
		}
		else if(!strcasecmp(cmd,"list")) list_badchans(nick, chaninfo, parc, parv);
		return;
	}
	if(!strcasecmp(type,"nick"))
	{
		if(!strcasecmp(cmd,"add"))
		{
			if(parc<3)
			{
				csntc(nick, "Syntaxe: ABAD USER ADD <mask/nick>");
				return;
			}
			parv[1]=parv[3];
			add_badnick(nick,chaninfo,parc,parv);
		}
		else if(!strcasecmp(cmd,"del"))
		{
			if(parc<3)
			{
				csntc(nick, "Syntaxe: ABAD USER ADD DEL <mask/user>");
				return;
			}
			parv[1]=parv[3];
			del_badnick(nick,chaninfo,parc,parv);
		}
		else if(!strcasecmp(cmd,"list")) list_badnicks(nick, chaninfo, parc, parv);
		return;
	}
	return;
}


/* Cette fonction de test est laiss comme exemple. C'est la faon type d'utiliser
   les links
void ma_cmd(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aChan *chptr;
	aLink *lp;

	for(chptr = chanhead;chptr;chptr=chptr->next)
	{
		csntc(nick, "%s", chptr->chan);
		for(lp=chptr->access;lp;lp=lp->next)
		{
			csntc(nick, "%s", lp->value.a->user->nick);
		}
	}
	return;
} */

