/* src/chanserv.c - Diverses commandes sur le module chanserv
 * Copyright (C) 2002-2003 Inter System
 *
 * contact: Gay@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <ctype.h>
#include <time.h>
#include <main.h>

CVSINFO("$Id: chanserv.c,v 1.2 2003/02/02 17:47:00 romexzf Exp $");

/*
 * show_access
 *
 * parv[0] = bot
 * parv[1] = chan
 * parv[2] = recherche
 */
void show_access(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aLink *lp;
	char *nick2 = NULL, lev[4], comp='\0';
	int i = 0;
	int autoop,protect,suspend,autovoice;

	nick2=parv[2];
	if(*nick2 == '>' || *nick2 == '<' || *nick2 == '=')
	{
		comp=*nick2;
		strncpy(lev, ++nick2, 4);
		if(parc > 2)
		{
			csntc(nick, "Ne pas mettre d'espace entre les caractres <,>,= et le niveau");
			return;
		}
		if(!is_num(lev))
		{
			csntc(nick, "La valeur du niveau doit etre numrique derrire < ou > ou =");
			return;
		}
	}
	autoop=getoption("-autoop",parv,parc,2,-1);
	autovoice=getoption("-autovoice",parv,parc,2,-1);
	protect=getoption("-protect",parv,parc,2,-1);
	suspend=getoption("-suspend",parv,parc,2,-1);
	csntc(nick, "------------------[ \0032\002%s\002\0036 > Liste des accs\003      ]------------------", chaninfo->chan);

	for(lp = chaninfo->access;lp;lp=lp->next)
	{
		if((
			 (comp!='\0' && ((comp=='>' && lp->value.a->level > atoi(lev))
			                 || (comp=='<' && lp->value.a->level < atoi(lev))
			                 || (comp=='=' && atoi(lev) == lp->value.a->level)))
			 || (*nick2=='*')
			 || ( (!strchr(nick2, '*') || !strchr(nick2, '?'))
			      && !match(nick2, lp->value.a->user->nick))
			 || strstr(lp->value.a->user->nick, nick2))
			&& (!autoop || AOp(lp->value.a))
			&& (!autovoice || AVoice(lp->value.a))
			&& (!protect || AProtect(lp->value.a))
			&& (!suspend || ASuspend(lp->value.a)))
		{
			show_accessn(lp->value.a, lp->value.a->user, nick);
			csntc(nick, "-");
			i++;
		}
	}
	csntc(nick, "Un Total de %d entre%s trouve%s", i, i > 1 ? "s" : "", i > 1 ? "s": "");
	return;
}

void show_accessn(struct access *access, struct userinfo *user, aNick *num)
{
	char options[100], *auth, t[70];

	options[0]='\0';
	if(AOp(access)) strcat(options, " autoop");
	if(AProtect(access)) strcat(options, " protg");
	if(AVoice(access)) strcat(options, " autovoice");
	if(ASuspend(access) || user->suspendu > 0) strcat(options, " suspendu");
	auth = user->n ? "Oui" : "Non";
	if(options[0] == '\0') strcpy(options, " Aucune");

	csntc(num, "\002Username:\002 %s \002Niveau:\002 %d \002Identifi:\002 %s", user->nick, access->level, auth);
	csntc(num, "\002Options:\002%s", options);


/* Dsactivation de l'information sur la dernire visite de l'utilisateur en attendant qu'un
d'entre nous corrige l'erreur qui affiche dernire visite en 1970 mdr - Keeo */
    get_time(access->lastseen, t);
	csntc(num, "\002Dernire visite:\002 %s", access->lastseen == 1 ? "Actuellement dans le salon" : t);
/* Fin - ven01nom2002 */

	if(access->info[0] != '\0') csntc(num, "\002Infoline:\002 %s", access->info);
	return;
}

/*
 * add_user
 *
 * parv[1] = salon
 * parv[2] = username
 * parv[3] = niveau
 */
void add_user(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anUser *u;
	aWaitAccess *wa;
	char *username = parv[2], *salon = parv[1], memo[MEMOLEN];
	int niveau, flag = 0;

	if(!(u=getuserinfo(username)))
	{
		csntc(nick, NOSUCHUSER, username);
		return;
	}

	if(!is_num(parv[3]))
	{
		csntc(nick, "Le niveau doit tre un nombre");
		return;
	}
	niveau = atoi(parv[3]);
	if(niveau < 5 || niveau >= 500)
	{
		csntc(nick, "Le niveau doit tre entre 5 et 499");
		return;
	}
	if(!nick->user || (niveau >= ChanLevelbyUserI(nick->user, salon) && !IsAnAdmin(nick->user)))
	{
		csntc(nick, "Le niveau ne doit pas tre plus grand que le votre");
		return;
	}
	if(u->flag & U_PREJECT)
	{
		csntc(nick, "\2%s\2 refuse systmatiquement les propositions d'accs.", u->nick);
		return;
	}
	else if(u->flag & U_PACCEPT)
	{
		if(ChanLevelbyUserI(u, salon))
		{
			csntc(nick, "%s a dj un accs sur %s.", username, salon);
			return;
		}
		if(niveau >= 400) flag |= (A_OP | A_PROTECT);
		add_access(u, salon, niveau, flag, "", time(NULL));
		write_anuser(u);
		csntc(nick, "\2%s\2 a maintenant un accs sur \2%s\2 (%d)", u->nick, salon, niveau);
		if(u->n) csntc(u->n, "\2%s\2 vous a donn un accs sur \2%s\2 (%d)", nick->nick, salon, niveau);
		else
		{
			snprintf(memo, MEMOLEN, "\2%s\2 vous a donn un accs sur \2%s\2 (%d)", nick->nick, salon, niveau);
			add_memo(u, nick->user->nick, time(NULL), memo);
		}
		return;
	}
	else
	{
		for(wa = u->wahead;wa;wa = wa->next)
			if(!strcasecmp(salon, wa->chan))
			{
				csntc(nick, "Vous avez dj propos un access  %s", username);
				return;
			}
		if(ChanLevelbyUserI(u, salon))
		{
			csntc(nick, "%s a dj un accs sur %s.", username, salon);
			return;
		}
		add_waitaccess(u, salon, niveau);
		csntc(nick, "Vous avez bien propos  %s un access sur %s. Il va recevoir une notice ou un memo lui demandant de confirmer ou de refuser cet access", username, salon);

		if(u->n)
		{
			csntc(u->n, "%s vous a propos un access de %d sur %s.", nick->nick, niveau, salon);
			csntc(u->n, "Pour accepter tapez:\2 /%s okaccess %s OUI \2, pour refuser tapez:\2 /%s okaccess %s NON", cs.nick, salon, cs.nick, salon);
		}
		else
		{
			snprintf(memo, MEMOLEN, "%s vous a propos un access de %d sur %s. Pour l'accepter tapez \2/%s okaccess %s OUI\2 et pour le refuser tapez \2/%s okaccess %s NON", nick->nick, niveau, salon, cs.nick, salon, cs.nick, salon);
			add_memo(u, nick->user->nick, time(NULL), memo);
		}
		write_anuser(u);
		return;
	}
	return; /* on sait jamais :P */
}

/*
 * del_user
 *
 * parv[1] = #salon
 * parv[2] = username
 */
void del_user(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	anUser *u;
	char *salon = parv[1], *username = parv[2];
	int niveau;

	if(!(u=getuserinfo(username)))
	{
		csntc(nick, NOSUCHUSER, username);
		return;
	}
	if(!(niveau = ChanLevelbyUserI(u, salon)))
	{
		csntc(nick, "%s n'a pas d'accs sur %s", username, salon);
		return;
	}
	if(ChanLevelbyUserI(nick->user, salon) <= niveau && nick->user->level < 2)
	{
		csntc(nick, "Vous ne pouvez pas deluser un user d'un niveau suprieur ou gal au votre.");
		return;
	}
	if(niveau == 500)
	{
		csntc(nick, "Vous ne pouvez pas deluser l'accs 500 du salon ! Veuillez utiliser UNREG ou CHAN DEL");
		return;
	}
	del_access(u, chaninfo);
	write_anuser(u);
	csntc(nick, "%s n'a plus d'accs sur %s", username, salon);
	if(u->n) csntc(u->n, "%s a supprim votre accs sur %s", nick->nick, salon);
	return;
}

void kick(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char r[150], *c = parv[1];
	aNick *targ;

	/* Verifications des protections de la cible. */
	if(!strcasecmp(cs.nick, parv[2]))
	{
		csntc(nick, "Je suis pas sur que a soit prfrable pour \2%s\2...", chaninfo->chan);
		return;
	}
	if(!(targ = getnickbynick(parv[2])))
	{
		csntc(nick, NOTCONNECTED, parv[2]);
		return;
	}
	if(strchr(targ->modes, 'k'))
	{
		csntc(nick, "\2%s\2 est un Service. (+k)", targ->nick);
		return;
	}
	if(!(getjoininfo(targ, chaninfo->chan)))
	{
		csntc(nick, "\2%s\2 n'est pas sur %s", targ->nick, chaninfo->chan);
		return;
	}

	if(!check_protect(nick, targ, c)) return;

	if(parc < 3) strncpy(r, DEFRAISON, 150);
	else parv2msgn(parc, parv, 3, r, 150);

	cskick(c, targ->numeric, "(\2%s\2) %s", nick->user->nick, r);
	return;
}


void verify(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	struct nickinfo *u;

	if(!strcasecmp(parv[1], cs.nick))
	{
		csntc(nick, "Yeah, c'est bien moi :)");
		return;
	}

	if(!strcasecmp(nick->nick, parv[1])) u = nick;
	else u = getnickbynick(parv[1]);
	if(!u)
	{
		csntc(nick, NOTCONNECTED, parv[1]);
		return;
	}

	if(strchr(u->modes, 'k'))
	{
		csntc(nick, "%s est un Robot (\2Service\2).", u->nick);
		return;
	}

	if(!u->user)
	{
		csntc(nick, "%s n'est pas actuellement logu.", u->nick);
		return;
	}
	if(IsAnAdmin(nick->user) || !strcasecmp(nick->nick, u->nick)) csntc(nick, "%s!%s@%s est logu sous l'username %s %s %s", u->nick, u->ident, u->host, u->user->nick, (u->user->level > 1) ? "- Administrateur des Services" : "", u->is_oper ? "- IRCop" : "");
	else csntc(nick, "%s est logu sous l'username %s %s %s", u->nick, u->user->nick, IsAnAdmin(u->user) ? "- Administrateur des Services" : "", u->is_oper ? " - IRCop" : "");
	return;
}

void mode(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	int a = 0;
	char *mode = parv[2];

	if(strchr(mode, 'o') || strchr(mode, 'b') || strchr(mode, 'v'))
	{
		csntc(nick, "Vous n'tes pas autoris  changer les Ops,Voices,Bans avec cette commande.");
		return;
	}
	if(HasMode(nick, 'o') && strchr(mode, 'O'))
	{
		csntc(nick, "Vous n'tes pas autoris  changer ce mode (O)");
		return;
	}
	if(strchr(mode, 'k')) a++;
	if(strchr(mode, 'l')) a++;
	csmode(chaninfo, "%s %s %s", mode, (a && parc > 2) ? parv[3] : "", (a > 1 && parc > 3) ? parv[4] : "");
	write_achan(chaninfo);
	return;
}

void topic(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char topic[TOPICLEN];
	if(CLockTopic(chaninfo))
	{
		csntc(nick, "Le LOCKTOPIC est actif sur %s", parv[1]);
		return;
	}
	parv2msgn(parc, parv, 2, topic, TOPICLEN);
	cstopic(chaninfo, "%s", topic);
	write_achan(chaninfo);
	return;
}

void rdeftopic(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	if(CLockTopic(chaninfo))
	{
		csntc(nick, "Le LOCKTOPIC est actif sur %s", parv[1]);
		return;
	}
	if(chaninfo->deftopic[0] != '\0') cstopic(chaninfo, "%s", chaninfo->deftopic);
	return;
}

void rdefmodes(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	csmode(chaninfo, "-ipsmtnqcCOklr *");
	if(chaninfo->defmodes[0] != '\0') csmode(chaninfo, "%s", chaninfo->defmodes);
	return;
}

void info(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aLink *lp;
	anAccess *access=NULL;

	for(lp=chaninfo->access;lp && lp->value.a->user != nick->user;lp=lp->next);
	if(!lp) return;
	access = lp->value.a;

	if(parc < 2)
	{
		csntc(nick, "Veuillez prciser une infoline ou le mot cl 'none' pour la dfinir nulle.");
		return;
	}
	if(!strcasecmp(parv[2], "none"))
	{
		access->info[0] = '\0';
		csntc(nick, "Infoline sur \002%s\002 a t supprime.", access->chan);
		return;
	}

	parv2msgn(parc, parv, 2, access->info, 199);
	csntc(nick, "Infoline de sur \002%s\002 change en: %s", access->chan, access->info);
	write_anuser(nick->user);
	return;
}

void invite(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char h[200];
	aBan *bans;
	aNick *n;

	if(parc < 2) n = nick;
	else if (!(n = getnickbynick(parv[2])))
	{
		csntc(nick, NOTCONNECTED, parv[2]);
		return;
	}
	bans = chaninfo->banhead;
#ifdef HAVE_CRYPTHOST
	snprintf(h, 200, "%s!%s@%s", n->nick, n->ident, n->crypt);
#else
	snprintf(h, 200, "%s!%s@%s", n->nick, n->ident, n->host);
#endif
	while(bans)
	{
		if(!match(bans->mask, h))
		{
			if(!IsAnAdmin(nick->user))
			{
				if(n==nick) csntc(nick, "Vous tes banni du salon %s : vous ne pouvez pas vous y inviter.", chaninfo->chan);
				else csntc(nick, "%s est banni du salon %s : vous ne pouvez l'y inviter", parv[2], chaninfo->chan);
				return;
			}
			break;
		}
		bans = bans->next;
	}
    putserv("%s %s %s :%s\n", cs.num, TOKEN_INVITE, n->nick, chaninfo->chan);
	return;
}

void clearmodes(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	csmode(chaninfo, "-ipsmtnqcCOklr *");
	csntc(nick, "Tous les modes de %s sont supprims.", parv[1]);
	return;
}

/*
 * see_alist
 *
 * parv[1] = chan
 */
void see_alist(aNick *nick, aChan *chan, int parc, char **parv)
{
	aLink *lp;

	csntc(nick, "------------------[ \0032\002%s\002\0036 > Liste des identifis\003 ]------------------", chan->chan);
	csntc(nick, "\002\037Pseudo Actuel\037 \037Username\037 \037Niveau\037");

	for(lp=chan->access;lp;lp=lp->next)
	{
		if(!lp->value.a->user->n) continue;
		csntc(nick, "%-13s %-8s %-6d", lp->value.a->user->n->nick, lp->value.a->user->nick, lp->value.a->level);
	}
}

/*
 * accept_an_access
 *
 * parv[1] = chan
 * parv[2] = oui/non
 */
void accept_an_access(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	aWaitAccess *wa;

	if(parc < 2) return;

	if(strcasecmp(parv[2], "OUI") && strcasecmp(parv[2], "NON"))
	{
		csntc(nick, "Syntaxe: OKACCESS %s <OUI/NON>", parv[1]);
		return;
	}
	if(!nick->user) /*dj vrifi mais on ne sait jamais*/
	{
		csntc(nick, "Vous devez avoir un username");
		return;
	}

	if(!(nick->user->flag & U_POKACCESS))
	{
		csntc(nick, "Vous ne pouvez utiliser cette commande ! Vous %s toutes les propositions d'accs !", (nick->user->flag & U_PACCEPT) ? "acceptez" : "refusez");
		return;
	}
	for(wa = nick->user->wahead;wa && strcasecmp(wa->chan, parv[1]);wa = wa->next);

	if(!wa)
	{
		csntc(nick, "Vous avez aucune proposition d'access sur %s", parv[1]);
		return;
	}
	if(wa->level > 499 || wa->level < 5)
	{
		csntc(nick, "La proposition d'access est invalide, suppression...");
		del_waitaccess(nick->user->nick, wa->chan);
		return;
	}
	if(!strcasecmp(parv[2], "OUI"))
	{
		int flag = 0;
		if(wa->level >= 400) flag |= (A_OP | A_PROTECT);
		csntc(nick, "Vous avez maintenant un access sur %s", wa->chan);
		add_access(nick->user, wa->chan, wa->level, flag, "", time(NULL));
	}
	else
		csntc(nick, "La proposition d'access sur %s a bien t rejet", wa->chan);
	del_waitaccess(nick->user->nick, parv[1]);
	write_anuser(nick->user);

	return;
}

void admin_say(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char buf[400];
	parv2msgn(parc, parv, 2, buf, 400);

	putserv("%s %s %s :%s\n", cs.num, TOKEN_PRIVMSG, parv[1], buf);
	return;
}

void admin_do(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char buf[400];
	parv2msgn(parc, parv, 2, buf, 400);

	putserv("%s %s %s :\001ACTION %s\001\n", cs.num, TOKEN_PRIVMSG, parv[1], buf);
	return;
}

